package se.chalmers.paragon;

/**
 * To be thrown when an operation on a lock (open/close/isOpen) is called with
 * the wrong number of arguments.
 * 
 * @author Paragon Developers (http://www.cse.chalmers.se/paragon)
 * 
 */
public class LockArityError extends Error {

	private static final long serialVersionUID = 1L;

	private ConcreteActor[] input;
	private Lock lock;

	private Lock locka;

	private Lock lockb;

	public LockArityError(ConcreteActor[] input, Lock lock) {
		this.input = input;
		this.lock = lock;
	}
	
	public LockArityError(Lock locka, Lock lockb) {
		this.locka = locka;
		this.lockb = lockb;
	}

	private String inputAsString() {
		String res = "[";
		for (int i = 0; i < input.length - 1; i++) {
			res += input[i].toString() + ",";
		}
		if (input.length > 0)
			res += input[input.length - 1].toString();
		res += "]";
		return res;
	}

	public String getMessage() {
		if (locka != null )
			return "Error comparing lock " + locka.getName() + " (arity "
					+ locka.getArity() + ") with lock " + lockb.getName()
					+ " (arity " + lockb.getArity() + ")";
		return "Error manipulating lock " + lock.getName() + " (arity "
				+ lock.getArity() + ") for instance " + inputAsString()
				+ " (arity " + input.length + ")";
	}

}
